#include	<process.h>
#include	<io.h>
#include	<fcntl.h>
#include	<alloc.h>
#include	"sim.h"


void	_Cdecl main(void);

void	locate(int	x,int	y)
{
	if(x <= 0)	x = 1;
	if(y <= 0)	y = 1;
	if(x > 80)	x = 80;
	if(y > 25)	y = 25;
	printf("\x1b[%d;%dH",y,x);
}

void	clr()
{
	printf("\x1b[2J");
}

void	make_heap_err(char	*p)
{
		printf("%s[ %s mۏo܂%s\n",
			&escolor[9],p,&escolor[0]);
		exit(0);
}

void	make_heap_init()
{
	if((parts=(element	*)calloc(MAXVAR,sizeof(element))) == NULL)
		make_heap_err("parts");
	if((bparts=(element	*)calloc(BMAX,sizeof(element))) == NULL)
		make_heap_err("bparts");
	if((varpool=(VAR	*)calloc(MAXVAR,sizeof(VAR))) == NULL)
		make_heap_err("varpool");
	if((bvarpool=(VAR	*)calloc(BMAX,sizeof(VAR))) == NULL)
		make_heap_err("bvarpool");
	if((fnc=(FNC	*)calloc(MAXDIM,sizeof(FNC))) == NULL)
		make_heap_err("fnc");
	if((bfnc=(FNC	*)calloc(MAXDIM,sizeof(FNC))) == NULL)
		make_heap_err("bfnc");
	if((ufnc=(UFNC	*)calloc(MAXDIM,sizeof(UFNC))) == NULL)
		make_heap_err("ufnc");
}


void	make_heap_ele(int	leng)
{
int	i;
char	sbuf[20];
	if(leng == 0)	return;
	if((weight=(double	*)calloc(leng,sizeof(double))) == NULL)
		make_heap_err("weight");
	if((ip=(int	*)calloc(leng,sizeof(int))) == NULL)
		make_heap_err("ip");
	if((xx=(complex	*)calloc(leng,sizeof(complex))) == NULL)
		make_heap_err("xx");
	if((s_pt=(char	**)calloc(leng*(leng+1),sizeof(char	*))) == NULL)
		make_heap_err("s_pt");
	if((sk=(char	*)calloc(30000,sizeof(char))) == NULL)
		make_heap_err("sk");
	ele = (complex	**)calloc(leng,sizeof(complex	*));
	for(i=0;i<leng;i++)
		if((ele[i]=(complex	*)calloc((leng+1),sizeof(complex))) == NULL){
			sprintf(sbuf,"ele[%d]",i);
			make_heap_err(sbuf);
		}
	for(i=0;i<leng*(leng+1);i++)	s_pt[i] = &dumy[0];
	dim_old = leng;
}


void	make_heap_grph()
{
	if((fi=(double	*)calloc(301,sizeof(double))) == NULL)
		make_heap_err("fi");
	if((fnowi=(double	(*)[5])calloc(301*5,sizeof(double))) == NULL)
		make_heap_err("fnow");
	if((ni=(int	(*)[6])calloc(301*6,sizeof(int))) == NULL)
		make_heap_err("ni");
}


void	free_heap_init()
{
	if(parts != NULL)	free(parts);
	if(bparts != NULL)	free(bparts);
	if(varpool != NULL)	free(varpool);
	if(bvarpool != NULL)	free(bvarpool);
	if(fnc != NULL)	free(fnc);
	if(bfnc != NULL)	free(bfnc);
	if(ufnc != NULL)	free(ufnc);
}


void	free_heap_ele()
{
int	i;
	if(dim_old == 0)	return;
	if(weight != NULL)	free(weight);
	if(ip != NULL)	free(ip);
	if(xx != NULL)	free(xx);
	if(s_pt != NULL)	free(s_pt);
	if(sk != NULL)	free(sk);
	for(i=0;i<dim_old;i++)	if(ele[i] != NULL)	free(ele[i]);
	free(ele);
	dim_old = 0;
}


void	free_heap_grph()
{
	if(fi != NULL)	free(fi);
	if(fnowi != NULL)	free(fnowi);
	if(ni != NULL)	free(ni);
}


void	var_init()
{
int	j=0;
	if(dim_old > 0)	free_heap_ele();
	node = 0;
	dim = 0;
	calmode = 0;
	fnc_now = 0;
	memset(disp,-1,sizeof(disp));
	memset(parts,0,MAXVAR*sizeof(element));
	memset(varpool,0,MAXVAR*sizeof(VAR));
	memset(fnc,0,MAXDIM*sizeof(FNC));
	memset(vg,0,sizeof(vg));
	memset(load_now,0,sizeof(load_now));
	memset(ufnc,0,MAXDIM*sizeof(UFNC));
	f0 = j;
	strcpy(varpool[j++].id,"f");
	fl = j;
	strcpy(varpool[j++].id,"fl");
	fh = j;
	strcpy(varpool[j++].id,"fh");
	fs = j;
	strcpy(varpool[j++].id,"fs");
	ss = j;
	strcpy(varpool[j++].id,"s");
	strcpy(varpool[j].id,"pi");
	varpool[j].val.real = pai;
	make_var_no(ss,s_name);
}


char	gtchar(char	*v)
{		/*	Xy[XJbg	*/
	while((ch=v[chr_pnt++]) == ' ') ;
	/*	̍Ō̏	*/
	if(ch == '\0')	chr_pnt--;
	/*	啶Ȃ珬ɕϊ	*/
	if(isupper(ch))	ch = tolower(ch);
	return(ch);
}


char	gtchar_start(char	*v)
{	/*	̐擪當荞	*/
	/*	̃|C^擪̈ʒuɃZbg	*/
	chr_pnt = 0;
	/*	P荞	*/
	gtchar(v);
	return(ch);
}


void	getname(char	*v)
{	/*	񂩂p̖Oname[80]ɂPTȓŎ荞	*/
	/*	PTȍ~͓ǂݎ̂Ă	*/
int	i=0;
	name[i++] = ch;
	while(isalnum(gtchar(v)) && i<15)
		name[i++] = ch;
	name[i] = '\0';
	while(isalnum(ch))
		gtchar(v);
}


/*	^ꂽ varpool ɓo^Ă΁AiԍԂ	*/
int	var_name_test(char	*ls)
{
int	j;
	for(j=0;j<MAXVAR;j++)	{
		if(varpool[j].id[0] == '\0')	return(-1);
		if(strcmp(varpool[j].id,ls) == 0)	return(j);
	}
}


/*	^ꂽ parts ̃}X^[Ɠ΁A
		p[cԍԂ	*/
int	master_name_test(char	*ls)
{
int	j;
	for(j=0;j<MAXVAR;j++)	{
		if(parts[j].attr == '\0')	return(-1);
		if(strcmp(parts[j].slave,ls) == 0)	return(j);
	}
}


char	*get_lower_string(char	*ls)
{  /*      L[{[h̓ob`t@C當 ls ɓǂݍ  */
int	i;
get_lower_loop:
	if(bat)	
		if(feof(fpbat[bat]))	{
			fclose(fpbat[bat--]);
			printf("%d Ԃ̃ob`t@C %s I܂B\n",
				bat+1,&bat_name[bat+1][0]);
			goto	get_lower_loop;
		}
	ls[0] = ls[79] = '\0';
	fgets(ls,79,fpbat[bat]);
	i = strlen(ls)-1;
	if(ls[i] == '\n')	ls[i] = '\0';
	/*	ob`t@C̃RgF\		*/
	if(bat>0 && ls[0] == '%')	{
		printf("%s%s%s\n",&escolor[6],&ls[1],&escolor[0]);
		goto	get_lower_loop;
	}
	if(ls[0] != '%')	strlwr(ls);
	/*	ob`t@CŃL[͂҂	*/
	if(bat>0 && strcmp(ls,"/wait") == 0)	{
		printf("%sL[͑҂H %s",&escolor[9],&escolor[0]);
		gets(ls);
		strlwr(ls);
	}
	/*	ob`t@CL[͂܂͕ŏI鏈	*/
	if(bat>0 && strcmp(ls,"/exit") == 0)	{
		bat = 0;
		printf("%sob`t@CI܂%s\n",
			&escolor[11],&escolor[0]);	/*	΂̃o[X	*/
		fcloseall();
		ls[0] = '\0';
		return(ls);
	}
	/*	ob`t@C̐擪ɖ߂鏈	*/
	if(bat>0 && strcmp(ls,"/rewind") == 0)	{
		clr();
		printf("%sob`t@C %s ̐擪ɖ߂܂%s\n\n",
			&escolor[2],&bat_name[bat][0],&escolor[0]);
		fseek(fpbat[bat],0L,0);
		goto	get_lower_loop;
	}
	/*	ob`t@C̍Ō܂ŃXLbv鏈	*/
	if(bat>0 && strcmp(ls,"/skip") == 0)	{
		clr();
		printf("%sob`t@C %s XLbv܂%s\n\n",
			&escolor[2],&bat_name[bat][0],&escolor[0]);
		fseek(fpbat[bat],0L,2);
		goto	get_lower_loop;
	}
	if(bat)	{
		printf("%s\n",ls);
		if(feof(fpbat[bat]))	{
			fclose(fpbat[bat--]);
			printf("%d Ԃ̃ob`t@C %s I܂B\n",
				bat+1,&bat_name[bat+1][0]);
		}
	}
	if(mkbat)	{
		if(ls[0] != '#')	fprintf(batfile,"%s\n",ls);
		else	{
			mkbat = 0;
			fclose(batfile);
			printf("%sob`t@C %s ̍쐬I܂B%s\n",
				&escolor[12],&bat_name[0][0],&escolor[0]);
			ls[0] = '\0';
		}
	}
	return(ls);
}


void	do_bat(char	*v)
{	/*	ob`t@CǂݍŎs	*/
	printf("ob`t@Č݂̃lXeBOx %d\n",bat);
	strcpy(name,&v[1]);
	if(bat > 9)	{
		printf("%sob`t@C̃lXeBO͂POx܂łłB\n",
			&escolor[9]);
		printf("̃t@C %s ̓I[vo܂%s\n",
			name,&escolor[0]);
		gets(aa);
		return;
	}
	/*	ob`t@C̃GNXeV .sb t	*/
	fname_get(name,".sb");
	if((fpbat[++bat]=fopen(name,"r")) == 0)	{
		fullname(name,dir);
		if((fpbat[bat]=fopen(name,"r")) == 0)	{
			bat--;
			printf("%sob`t@C %s I[vo܂%s\n",
				&escolor[9],name,&escolor[0]);
			return;
		}
	}
	strcpy(&bat_name[bat][0],name);
	printf("ꂩob`t@C %s s܂\n",name);
}


void	make_bat()
{	/*	ob`t@C쐬	*/
char	sl[15];
	if(bat > 0)	{
		printf("%sob`t@CsɃob`t@C̍쐬͏o܂B%s\n",
			&escolor[9],&escolor[0]);
		return;
	}
	if(mkbat > 0)	{
		mkbat = 0;
		fclose(batfile);
		printf("ob`t@C %s ̍쐬I܂B\n",&bat_name[0][0]);
		return;
	}
	mkbat = 1;
make_bat_loop:
	printf("ob`t@C쐬܂B t@Ć@H@");
	get_fname_get(name,".sb");
	/*	ob`t@C͂ā@.sb t	*/
	if((batfile=fopen(name,"r")) != 0)	{
		fclose(batfile);
		printf("%sob`t@C %s ͊ɑ݂܂ !\n",
			&escolor[13],name);
		printf("1 .. dÃL[Ȃt@Cē ? %s",
			&escolor[0]);
		gets(sl);
		if(sl[0] != '1')	goto	make_bat_loop;
	}
	if((batfile=fopen(name,"w")) == 0)	{
		printf("%st@C %s I[vo܂ !%s\n",
			&escolor[9],name,&escolor[0]);
		mkbat = 0;
		return;
	}
	strcpy(&bat_name[0][0],name);
	printf("%sob`t@C %s ̍쐬Jn܂ !\n",
		&escolor[12],name);
	printf("R}hCĂ # ͂܂ő܂B%s\n",
		&escolor[0]);
}


void	mode()
{	/*	݂̓샂[h\	*/
int	i;
	printf("%s",&escolor[6]);
	if(fl_out == 1)	printf("f[^t@C쐬");
	else	printf("f[^t@C쐬Ȃ");
	printf("...... /mk ܂ /nomk Ő؂ւ\n");
	if(pdb == 1)	printf("fVxlŌvZ郂[h");
	else	printf("lŌvZ郂[h");
	printf("...... /db ܂ /val Ő؂ւ\n");
	if(manu == 0)
		printf("vZXebṽ[h /auto i؂ւjł\n");
	else	printf("vZXebṽ[h /manu i䋉jł\n");
	printf("...... /auto ܂ /manu Ő؂ւ\n");
	printf("䋉̃|Cg %d ł",gpos);
	printf("...... /gpos Őݒ肷\n");
	if(parts[0].attr == '\0')	printf("HXg܂\n");
	else {
		if(calmode == 0)	{
			printf("V~[Vɂ \m[hݒ\n");
			for(i=0;i<MAXDIM;i++)
				if(disp[i] == i+1)	printf("%d ",disp[i]);
			printf("\n");
		}
		else	{
			printf("V~[Vɂ vZݒ\n");
			/*	caln ̓V~[VvŽ	*/
			for(i=0;i<caln;i++)	printf("p%-3d %s\n",i+1,calx+i*80);
		}
	}
	if(bmode == 1)
		printf("ubNL[{[h͂郂[h");
	else	printf("ubNHXg瓾郂[h");
	printf("...... /bmode Őݒ肷\n");
	printf("V~[VER}ȟvZ ");
	if(calmode == 1)
		printf("/disp Őݒ肵vZ郂[h\n");
	else	printf("m[hd݂̂ŌvZ郂[h\n");
	printf("...... /cal Őݒ肷%s\n",&escolor[0]);
}


void	valdb()
{
	if(pdb == 1)	printf("mode = fVxlŌvZ郂[h\n");
	else	printf("mode = lŌvZ郂[h\n");
}


void	help()
{
	clr();
	printf("%s",&escolor[6]);
	printf("fq         %sAiOHV~[VvOVer3.0%s%s\n",
		&escolor[12],&escolor[4],&escolor[0]);
	printf("ƗfqFe	i	r	l	c\n");
	printf("]fqFk...i to i	v...e to e	q...e to i	w...i to e\n");
	printf("ubNfqFb		֐fqFf\n");
	printf("\n%s",&escolor[6]);
	printf("R}h : %s/ + R}h\n",&escolor[4]);
	printf("ipart	cpart	dpart	padd	node	parts	free	dir	help\n");
	printf("range	point	para	ac	grph	disp	conv	auto	manu\n");
	printf("cmode	smode	mode	db	val	mk	nomk	gpos	bmode\n");
	printf("cal	save	load	bload	fname	def	dvar	dfnc	end\n%s",&escolor[6]);
	printf("DOS R}h :%s ! + MS-DOS R}h\n%s",&escolor[4],&escolor[6]);
	printf("ob`t@CsF%s",&escolor[4]);
	printf(" @ + t@C .... Rgs %% Ŏn߂\n%s",&escolor[6]);
	printf("ob`t@C쐬EIF%s",&escolor[4]);
	printf(" #        |___ L[͑҂    /wait\n");
	printf("                          __________|___ f̎w @   /exit\n");
	printf("%s",&escolor[6]);
	printf("vZŎgp\Ȉq    %s",&escolor[4]);
	printf("|___ ߂ /rewind,XLbv /skip\n");
	printf("$a	j()	~()	abs	sqrt	arg	log	log10	db\n");
	printf("exp	udb	sin	cos	tan	asin	acos	atan	\n");
	printf("real	image	pow	unpw	hex	khex	mhex\n");
	printf("\n%s",&escolor[6]);
	printf("VXeϐ        Ot̐F\n%s",&escolor[4]);
	printf("f fl fh fs s pi     P΁@QF@Rԁ@SF@TF\n");
	printf("\n");
	printf("%s",&escolor[0]);
}


/*	fq̒ǉ	*/
void	padd_c()
{
int	j;
		for(j=0;j<MAXVAR;j++)	{
			if(parts[j].attr == 0)	break;
		}
		dparts();
		free_heap_ele();
		padd(j);
}


/*	m[h\	*/
void	node_c()
{
	printf("ő̃m[hԍ = %d\n",node);
}


void	free_c()
{
	printf("[̎c = %ld\n",coreleft());
}


void	dir_c()
{
	clr();
	printf("%s",&escolor[6]);
	printf(".cir, .sb t@C̃fBtHgfBNgύX܂\n");
	printf("\ñ݂fBNg̐ݒ %s ł\n\n",dir);
	printf("Vݒ͂ĉ  %s",&escolor[0]);
	get_lower_string(aa);
	if(aa[0] != '\0')	strcpy(dir,aa);
}


/*	g f ɂ闘	*/
void	point_c()
{
	if(go_check() > 0)	return;
	printf("%sf[%s]%s\n",
		&escolor[5],coma(varpool[f0].val.real,-10),&escolor[0]);
	simu_point(0);
}


/*	WšvZiɂ鎮j		*/
void	conv_c()
{
	d_conv = 1;
	convmat();
	d_conv = 0;
}


/*	mode clear	*/
void	cmode_c()
{
	fl_out = 0;
	pdb = 0;
	manu = 0;
	gpos = 32;
	bmode = 0;
	calmode = 0;
	mode();
}


/*	mode set	*/
void	smode_c()
{		/*	V~[VR}hŃf[^t@C쐬	*/
	fl_out = 1;
	/*	fVxlŌvZ	*/
	pdb = 1;
	mode();
}


/*	fVx\	*/
void	db_c()
{
	pdb = 1;
	valdb();
}


/*	l\	*/
void	val_c()
{
	pdb = 0;
	valdb();
}


/*	f[^t@C쐬郂[h	*/
void	mk_c()
{
	fl_out = 1 ;
	mode();
}


/*	f[^t@C쐬Ȃ[h	*/
void	nomk_c()
{
	fl_out = 0 ;
	mode();
}


/*	[ht@C̕\	*/
void	fname_c()
{
	printf("ݓǂݍłt@C = %s\n",load_now);
}


/*	IɑΐEjA؂ւ	*/
void	auto_c()
{
	manu = 0;
}


/*	ɑΐ[hɂ	*/
void	manu_c()
{
	manu = 1;
}


/*	vZ̃|Cgݒ肷	*/
void	gpos_c()
{
	printf("MANU ON ܂ ō/Œ̔䂪POȏ̎ɁA\n");
	printf("V~[VŌvZ|Cg͂ĉ\n");
	printf("Œ 5 ȏAő 300 ȉ̐͂ĉ\n");
	printf("݂̐ݒ %d ł\n",gpos);
	get_lower_string(aa);
	if(atoi(aa) != 0)
		if(atoi(aa)<5 || atoi(aa)>300)	{
		gpos = 32;
		}
		else	gpos = atoi(aa);
	printf("gpos = %d ɐݒ肵܂\n",gpos);
}


/*	ubN̎擾@̃[h	*/
void	bmode_c()
{
	printf("ubNHXg̏񂩂瓾ȂA0 ͂ĉ\n");
	printf("ubNL[{[h͂ȂA1 ͂ĉ  ");
	get_lower_string(aa);
	if(atoi(aa) == 1)	bmode = 1;
	else	bmode = 0;
}


/*	para,range ̌vZm[hdōsȂ
		disp Őݒ肵ōsȂݒ肷	*/
void	cal_c()
{
	printf("%sV~[VR}ȟvZ ",&escolor[6]);
	if(calmode == 1)
		printf("/disp Őݒ肵vZ郂[hł\n");
	else	printf("m[hd݂̂ŌvZ郂[hł\n");
	printf("\n]ʂm[hd݂̂ōsȂȂ@O\n");
	printf("/disp Őݒ肵vZȂ@@P%s  ",
		&escolor[0]);
	get_lower_string(aa);
	if(atoi(aa) == 1)	{
		calmode = 1;
		if(calx == NULL)	{
			if((calx=(char	*)calloc(MAXDIM*80,sizeof(char))) == NULL)	{
				printf("%s[ calx mۏo܂%s\n",
					&escolor[9],&escolor[0]);
				exit(0);
			}
		}
	}
	else	calmode = 0;
	disp_sel();
}


/*	sim.exȅI	*/
void	end_c()
{
	printf("sim.exe@I܂\n\n");
	fcloseall();
	free_heap_init();
	if(dim_old > 0)	free_heap_ele();
	if(calx != NULL)	free(calx);
	exit(0);
}


void	command(char	*v)
{	/*	R}h̎s	*/
char	*comd;
int	j;
	fp = stdout;
	getname(v);
	/*	MS-DOS R}h̎s	*/
	if(v[0] == '!')	{
		comd = v+1;
		system(comd);
		return;
	}
	for(j=0;j<40;j++){
		if(cmnd[j][0] == '\0'){
			printf("%s ƂR}h͂܂II\n",name);
			return;
		}
		if(strcmp(name,cmnd[j]) == 0){
			(*exec_fnc[j])();
			return;
		}
	}
}


void _Cdecl	main(void)
{
double	y = 1.0;
complex	b;
char	*v;
int	i;
	make_heap_init();
	pai = 4*atan(y);
	var_init();
	fpbat[0] = stdin;
	help();
	printf("free = %ld\n",coreleft());
	for(;;)	{
		if(bat)	printf("B? ");
		else if(mkbat)	printf("M? ");
				 else printf("? ");
		get_lower_string(aa);
		v = &aa[0];
		if((*v == '\0') || (*v == '%'))	continue;
		gtchar_start(v);
		switch(ch){
			case	'/':	/*	R}h̎s	*/
			case	'!':	gtchar(v);
									command(v);
									continue;
			case	'@':	/*	ob`t@Cɂ鏈̎	*/
									do_bat(v);
									continue;
			case	'#':	/*	ob`t@C̍쐬EI	*/
									make_bat();
									continue;
			case	'>':	/*	ǑvZʂϐɑ	*/
									var_dainyu(v,&b);
									break;
			default	 :	/*	vŽvZ	*/
									jparse(&b,v);
									break;
		}
		printf("%s j ",coma(b.real,10));
		printf("%s\n\n",coma(b.image,-10));
	}
}